﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SparklineInGrid.Controllers;
using Newtonsoft.Json;
using SparklineInGrid.Models;

namespace SparklineInGrid.Controllers
{
    public class HomeController : Controller
    {
        public static AdventureWorksModelContainer context = new AdventureWorksModelContainer();
        public static NorthwindEntities nw = new NorthwindEntities();
        //
        // GET: /Home/

        public ActionResult Index()
        {
            ViewBag.Message = "This demo demonstrates the Ignite UI Sparkline inside a Grid scenario.";

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "This demo demonstrates the Ignite UI Sparkline inside a Grid scenario.";
            return View();
        }

        public ActionResult MVCDemo()
        {
            ViewBag.Message = "Ignite UI Sparkline showing vacation hours status for employees in each department in a column display type with vertical axis visible. Sparklines are presented in an unbound column and values are provided via a formula and are not very accurate :) Column Hiding is enabled. Windows UI theme, Responsive behaviour applied for better usability on touch devices. ";
            /* Lie and cheat to make the Departments with Employees and also allow it be normally seriazable */
            var departments = context.Departments.Select(d => new
            {
                DepartmentID = d.DepartmentID,
                Name = d.Name,
                GroupName = d.GroupName,
                ModifiedDate = d.ModifiedDate,
                Employees = d.EmployeeDepartmentHistories.Where(x => x.DepartmentID == d.DepartmentID).Where(x => x.EndDate == null).Select(x => x.Employee).Select(x => new
                {
                    BusinessEntityID = x.BusinessEntityID,
                    DepartmentID = d.DepartmentID,
                    NationalIDNumber = x.NationalIDNumber,
                    LoginID = x.LoginID,
                    OrganizationLevel = x.OrganizationLevel,
                    JobTitle = x.JobTitle,
                    BirthDate = x.BirthDate,
                    MaritalStatus = x.MaritalStatus,
                    Gender = x.Gender,
                    HireDate = x.HireDate,
                    SalariedFlag = x.SalariedFlag,
                    VacationHours = x.VacationHours,
                    SickLeaveHours = x.SickLeaveHours
                })
            }).AsQueryable();
            return View(departments);
        }

        public ActionResult Demo()
        {
            ViewBag.Message = "Ignite UI Sparkline showing vacation hours for employees in each department in a column display type with vertical axis visible. Normal range is set between 10 and 60 and visible in gray. Sparklines are presented in an unbound column. Column Hiding is enabled. Windows UI theme, Responsive behaviour applied for better usability on touch devices. ";
            return View(context.People.Take(20));
        }

        public ActionResult HMVCDemo()
        {
            ViewBag.Message = "Ignite UI Sparkline showing an overview of Orders' Freight expences for each customer in a Hierarchical Grid. Normal range applied to easily spot outliers, markers active. Besides Responsive, the Sparkline default tooltips have been replaced using the popover style ones the grid brings for great touch experience. ";
            return View(nw.Customers.Take(20));
        }

        public ActionResult HDemo()
        {
            ViewBag.Message = "Ignite UI Sparkline showing an overview of Orders' Freight expences for each customer in a Hierarchical Grid. Normal range applied to easily spot outliers, only high and low markers active. Besides Windows UI theme and Responsive, the Sparkline default tooltips have been replaced using the popover style ones the grid brings for great touch experience. ";
            return View(nw.Customers.Take(20));
        }

        public JsonResult Departments()
        {
            var departments = context.Departments.Select(d => new
            {
                DepartmentID = d.DepartmentID,
                Name = d.Name,
                GroupName = d.GroupName,
                ModifiedDate = d.ModifiedDate,
                Employees = d.EmployeeDepartmentHistories.Where(x => x.DepartmentID == d.DepartmentID).Where(x => x.EndDate == null).Select(x => x.Employee).Select(x => new
                {
                    BusinessEntityID = x.BusinessEntityID,
                    DepartmentID = d.DepartmentID,
                    NationalIDNumber = x.NationalIDNumber,
                    LoginID = x.LoginID,
                    OrganizationLevel = x.OrganizationLevel,
                    JobTitle = x.JobTitle,
                    BirthDate = x.BirthDate,
                    MaritalStatus = x.MaritalStatus,
                    Gender = x.Gender,
                    HireDate = x.HireDate,
                    SalariedFlag = x.SalariedFlag,
                    VacationHours = x.VacationHours,
                    SickLeaveHours = x.SickLeaveHours
                })
            }).ToList();
            return Json(departments, JsonRequestBehavior.AllowGet);
        }
    }
}
